"""Проверка авторизации пользователя на сервере"""
import inspect
import logging
import sys
from socket import socket

import loggers.server_logs

logger = logging.getLogger('app.' + ('server' if sys.argv[0].find('client') == -1 else 'client'))


def login_required(func):
    '''
    Декоратор, проверяющий, что клиент авторизован на сервере.
    Проверяет, что передаваемый объект сокета находится в
    списке авторизованных клиентов.
    За исключением передачи словаря-запроса
    на авторизацию. Если клиент не авторизован,
    генерирует исключение TypeError
    '''

    def checker(*args, **kwargs):
        from messagers.server_messenger import ServerMessenger
        from common.variables import ACTION, PRESENCE
        if isinstance(args[0], ServerMessenger):
            found = False
            for arg in args:
                if isinstance(arg, socket):
                    for client in args[0].names:
                        if args[0].names[client] == arg:
                            found = True

            for arg in args:
                if isinstance(arg, dict):
                    if ACTION in arg and arg[ACTION] == PRESENCE:
                        found = True
            if not found:
                raise TypeError
        return func(*args, **kwargs)

    return checker
